Backendless.ServerCode.User.beforeLogin(async function (req) {
  const user = await Backendless.Users.login(req.login, req.password);

  if (!user.phoneNumber || !user.smsCodeAuth) {
    // if the user doesn't have phoneNumber or smsCodeAuth is not enabled, just return the logged-in user
    return user
  }

  // otherwise, send SMS with secret code and return to the client the transaction id
  const transactionId = await Backendless.CustomServices.invoke('Twilio', 'sendVerificationCode', user.phoneNumber);

  if (transactionId) {
    return { transactionId }
  }
});
