Backendless.ServerCode.User.beforeRegister(async function (req) {
  const user = req.user;

  if (user.transactionId) {
    // verify the received transactionId and transactionCode

    const transaction = await Backendless.CustomServices.invoke('Twilio', 'checkVerificationCode', {
      transactionId: user.transactionId,
      code         : user.transactionCode
    });

    // compare if the phoneNumber is not changed
    if (transaction.phoneNumber !== user.phoneNumber) {
      throw new Error('Phone Number is invalid');
    }

    // remove all the helper properties
    delete req.user.transactionId;
    delete req.user.transactionCode;

  } else if (user.phoneNumber && user.smsCodeAuth) {
    // if the user has phoneNumber and smsCodeAuth is enabled, send SMS to verify it
    const transactionId = await Backendless.CustomServices.invoke('Twilio', 'sendVerificationCode', user.phoneNumber);

    // the transactionId must be used again along with transactionCode value
    return Object.assign(req.user, { transactionId });
  }
});
